"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const path = require("path");
const gen_sdk_1 = require("./lib/meta/gen_sdk");
exports.default = (agent) => {
    const config = agent.config.controller;
    if (config.genSDK.enable) {
        let _a = config.genSDK, { enable, filter } = _a, rest = tslib_1.__rest(_a, ["enable", "filter"]);
        if (!rest.sdkDir) {
            throw new Error(`[egg-controller] NEED 'SDKDir' in config!`);
        }
        const ctrlDir = [].concat(config.ctrlDir).map(dir => {
            return path.isAbsolute(dir) ? dir : path.join(agent.baseDir, dir);
        });
        rest.sdkDir = path.isAbsolute(rest.sdkDir)
            ? rest.sdkDir
            : path.join(agent.baseDir, rest.sdkDir);
        console.log('[egg-controller] gen api sdk.');
        gen_sdk_1.genAPISDKByPath(ctrlDir, filter, rest, agent.config, config.fork);
        ctrlDir.forEach(dir => {
            agent.watcher.watch(dir, (file) => {
                console.log('[egg-controller] file changed', file.path);
                gen_sdk_1.genAPISDKByPath(ctrlDir, filter, rest, agent.config, config.fork);
            });
        });
    }
};
