import { Controller, EggAppConfig } from 'egg';
import { ControllerMetadataType, ControllerType, RouteType, MiddlewareType } from './type';
/** 控制器列表 */
export declare function getControllers(config: EggAppConfig): ControllerType[];
/** 路由列表 */
export declare function getRoutes<ExtType = any>(config: EggAppConfig): RouteType<ExtType>[];
export declare function addDefaultMiddleware(middleware: MiddlewareType | MiddlewareType[]): void;
export declare function getControllerMetadata(CtrlType: any): ControllerType;
export declare function controller(meta?: ControllerMetadataType): (target: any) => void;
export declare abstract class RESTfulController extends Controller {
    abstract index(): any;
    abstract new(): any;
    abstract show(id: any): any;
    abstract edit(id: string): any;
    abstract create(): any;
    abstract update(id: string): any;
    abstract destroy(id: string): any;
}
