"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.convert = void 0;
const ts = require("typescript");
function convert(data) {
    return typeof data === 'string'
        ? ts.createStringLiteral(data)
        : typeof data === 'number'
            ? ts.createNumericLiteral(`${data}`)
            : ts.createObjectLiteral(Object.keys(data)
                .filter(key => data[key])
                .map(prop => {
                return ts.createPropertyAssignment(prop, typeof data[prop] === 'string'
                    ? ts.createStringLiteral(data[prop])
                    : Array.isArray(data[prop])
                        ? ts.createArrayLiteral(data[prop].map(item => convert(item)), true)
                        : convert(data[prop]));
            }), true);
}
exports.convert = convert;
